Subject: Re: [RFC NET 00/04]: Increase number of possible routing tables

From: Ben Greear <[email-masked]>
Date: Fri, 07 Jul 2006 18:07:11 -0700

Patrick McHardy wrote:
> Ben Greear wrote:
> 
>>Patrick McHardy wrote:
>>
>>
>>>>I took on Ben's challenge to increase the number of possible routing
>>>>tables, these are the resulting patches.
>>
>>
>>I am seeing problems..though they could be with the way I'm using the tool
>>or pehaps I patched the kernel incorrectly.
>>
>>I applied the 3 patches to 2.6.17..all patches applied without problem,
>>but with a few lines of fuzz.  I get the same behaviour with and
>>without the new 'ip' patches applied.
>>
>>If I do an 'ip ru show', then I see lots of tables, though not all it
>>seems. (I have not tried beyond 205 yet).  But, if I do an
>>'ip route show table XX', then I see nothing or incorrect values.
> 
> 
> My patches introduced a bug when dumping tables which could lead to
> incorrect routes beeing dumped. A second bug (that already existed)
> makes the kernel fail when dumping more rules than fit in a skb.
> I think I've already seen the patch to address the second problem
> a short time ago sent by someone else. Anyway, this patch should
> fix both.

With this patch applied everything is looking much better.  I currently
have 400+ interfaces and one routing table per interface, and traffic
is passing as expected.

This is probably due to my own application polling interfaces for
stat updates...but I am seeing over 50% usage (with more system than user-space)
in this setup on an otherwise lightly loaded system.  top shows no process averaging
more than about 2% CPU (and only 2-3 are above 0.0 typically), which I find
a little strange.  load is around 3.0.

I'll dig into my code and see if I can tune the stat-gathering logic a bit...

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com